/* 
 * File:   main.c
 * Author: Jelora
 *
 * Created on 21 avril 2018, 22:56
 */
#pragma config FOSC = XT        // Oscillator Selection bits (XT oscillator)
#pragma config WDTE = OFF        // Watchdog Timer (WDT enabled)
#pragma config PWRTE = OFF      // Power-up Timer Enable bit (Power-up Timer is disabled)
#pragma config CP = OFF         // Code Protection bit (Code protection disabled)

#include <xc.h>


void modeAvecSynchroVideo();
void modeHorlogeInterne();
/*
 * 
 */
int main(int argc, char** argv) {
    
    PORTA = 0;
    PORTB = 0;
    TRISA = 0b00011100;
    TRISB = 0;
    //PORTBbits.RB0 = 1;
    
    // PORTAbits.RA2 entrée synchro
    // PORTAbits.RA3 entrée bouton panel
    // PORTAbits.RA4 sélection mode
    
    if ( PORTAbits.RA4 ){
        modeAvecSynchroVideo();
    }
    else{
        modeHorlogeInterne();
    }
    
    return (0);
}

void modeHorlogeInterne(){
    int i = 0;
    while ( 1 ){
        for ( i = 0 ; i < 2300 ; i++ ){
            // Boucle d'attente pour faire du 12Hz
        }
        if ( PORTAbits.RA3 == 0 ){
            if ( PORTBbits.RB0 ){
                PORTBbits.RB0 = 0;
            } 
            else{
                PORTBbits.RB0 = 1;
            }
        }
        else{
            PORTBbits.RB0 = 0;
        }
    }
}

void modeAvecSynchroVideo() {
    int periodeHaute = 0;
    int diviseur = 290;
    int comptagePeriode = 0;
    while ( 1 ){
        if ( PORTAbits.RA2 && periodeHaute == 0 ){
            periodeHaute = 1;
        }
        if ( PORTAbits.RA2 == 0 && periodeHaute == 1 ){
            periodeHaute = 0;
            comptagePeriode++;
            if ( comptagePeriode >= diviseur ){
                if ( PORTAbits.RA3 == 0 ){
                    if ( PORTBbits.RB0 ){
                        PORTBbits.RB0 = 0;
                    } 
                    else{
                        PORTBbits.RB0 = 1;
                    }
                }
                else{
                    PORTBbits.RB0 = 0;
                }
                comptagePeriode = 0;
            }
        }
    }
}

